leetcode - 91. Decode Ways

发布时间:2023年12月25日

Description

A message containing letters from A-Z can be encoded into numbers using the following mapping:

‘A’ -> “1”
‘B’ -> “2”

‘Z’ -> “26”
To decode an encoded message, all the digits must be grouped then mapped back into letters using the reverse of the mapping above (there may be multiple ways). For example, “11106” can be mapped into:

"AAJF" with the grouping (1 1 10 6)
"KJF" with the grouping (11 10 6)
Note that the grouping (1 11 06) is invalid because "06" cannot be mapped into 'F' since "6" is different from "06".

Given a string s containing only digits, return the number of ways to decode it.

The test cases are generated so that the answer fits in a 32-bit integer.

Example 1:

Input: s = "12"
Output: 2
Explanation: "12" could be decoded as "AB" (1 2) or "L" (12).

Example 2:

Input: s = "226"
Output: 3
Explanation: "226" could be decoded as "BZ" (2 26), "VF" (22 6), or "BBF" (2 2 6).

Example 3:

Input: s = "06"
Output: 0
Explanation: "06" cannot be mapped to "F" because of the leading zero ("6" is different from "06").

Constraints:

1 <= s.length <= 100
s contains only digits and may contain leading zero(s).

Solution

Recursive + memorization

Be careful of leading 0s

DP

Transformation equation:
d p [ i ] = ( d p [ i ? 2 ] ?? if? ?? s [ i ? 1 : i + 1 ] ?is?valid ) + ( d p [ i ? 1 ] ?? if? ?? s [ i ] ?is?valid ) dp[i] = (dp[i-2] \; \text{if } \;s[i-1:i+1] \text{ is valid}) + (dp[i-1] \; \text{if } \;s[i] \text{ is valid} ) dp[i]=(dp[i?2]if?s[i?1:i+1]?is?valid)+(dp[i?1]if?s[i]?is?valid)

Time complexity: o ( n ) o(n) o(n)
Space complexity: o ( n ) o(n) o(n)

Code

Recursive + memorization

class Solution:
    def __init__(self,):
        self.memo = {'': 1}

    def numDecodings(self, s: str) -> int:
        if s in self.memo:
            return self.memo[s]
        if s[0] == '0':
            return 0
        if len(s) == 1:
            return 1
        if len(s) == 2 and s <= '26':
            return 2 if s not in ('10', '20') else 1
        res = self.numDecodings(s[1:]) + (self.numDecodings(s[2:]) if s[:2] <= '26' else 0)
        self.memo[s] = res
        return self.memo[s]

Dynamic programming

class Solution:
    def numDecodings(self, s: str) -> int:
        def is_valid(s: str) -> bool:
            if len(s) == 1:
                return s[0] != '0'
            if len(s) == 2:
                return s[0] != '0' and s <= '26'
        dp = [0] * len(s)
        dp[0] = 1 if is_valid(s[0]) else 0
        if len(s) >= 2:
            dp[1] = (1 if is_valid(s[:2]) else 0) + (dp[0] if is_valid(s[1]) else 0)
        for i in range(2, len(s)):
            dp[i] = (dp[i - 2] if is_valid(s[i-1: i+1]) else 0) + (dp[i - 1] if is_valid(s[i]) else 0)
        return dp[-1]
文章来源:https://blog.csdn.net/sinat_41679123/article/details/135196486
本文来自互联网用户投稿,该文观点仅代表作者本人,不代表本站立场。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。